
var APP_ID = '1xxxxxxxxxxxxxxxxxxxxxxxxxxa';
var APP_SECRET = 'exxxxxxxxxxxxxxxxxa';

//global webview object to use for authorization, need on_error to call "oAuth2 WebView Complete" action
var gWebViewObj = 0;

//The tokens, to be used for the API's after Authorization
var OAUTH_ACCESS_TOKEN = '';
var OAUTH_REFRESH_TOKEN = '';

var REDIRECT_URI = 'http://localhost:8000/oauth.php';
var AUTHORIZE_URL = 'https://login.microsoftonline.com/common/oauth2/v2.0/authorize';
var TOKEN_URL = 'https://login.microsoftonline.com/common/oauth2/v2.0/token';
var SCOPE='openid offline_access profile mail.send Sites.ReadWrite.All Files.ReadWrite.All'; //note: offline_access required to get a refresh_token
var RESPONSE_MODE = 'query';
var RESOURCE_ID = 'https://graph.microsoft.com';

var SENDMAIL_ENDPOINT = '/v1.0/me/sendmail';

registerAction('setWebViewFocus', '', 'set web view focus', 'component:web:web_view');
function setWebViewFocus(webviewObj){
    
    setFocus(webviewObj);
    print('setting focus to webview..');
}

registerAction('oauth2Start', '', 'oAuth2 Start', 'component:web:web_view');
function oauth2Start(webviewObj){

    gWebViewObj = webviewObj;

    if (hasCookie('oauth_access_token')){
        //we have a token, so its all good
        OAUTH_ACCESS_TOKEN = getCookie('oauth_access_token');
        OAUTH_REFRESH_TOKEN = getCookie('oauth_refresh_token');
        print("OAUTH HAS TOKEN FROM COOKIE =" + OAUTH_ACCESS_TOKEN);
        setProperty(gWebViewObj, 'visible', false);
        callAction("show_page_by_name","home",3);
        
    }else{
        var url = AUTHORIZE_URL + '?client_id=' + urlEncode(APP_ID) + '&response_type=code&redirect_uri='+ urlEncode(REDIRECT_URI) + '&response_mode=' + RESPONSE_MODE + '&scope=' + urlEncode(SCOPE) + '&state=12345';
        print("URL to submit=" + url);
        setProperty(gWebViewObj, 'visible', true);
        callAction('set_web_view_url', webviewObj, url);
    }
}

registerAction('oauth2clear', '', 'oAuth2 Clear', '');
function oauth2clear(){
    deleteCookie('oauth_access_token');
    deleteCookie('oauth_refresh_token');
}

//Should go in the webview on_complete or on_error event, to see if the url is the one we need
registerAction('webviewMonitor', '', 'oAuth2 WebView Complete', 'string:url:[url]');
function webviewMonitor(url){
    print('webviewMonitor url=' + url);
  
    if (url.indexOf('http://localhost:8000/oauth.php?code=') !== -1){
        var code = getParameterByName(url);
        print('we have a code yay=' + code);
        //callAction('show_popup', 'code=' + code);
        setProperty(gWebViewObj, 'visible', false);
        getToken(code);

    }else{
        // callAction('show_popup', 'No code found');
    }
}


//Pull apart a URL and find a querystring param 
function getParameterByName(url) {
    var captured = /code=([^&]+)/.exec(url)[1]; // Value is in [1] ('384' in our case)
    var result = captured ? captured : 'myDefaultValue';
    return result;
}

//Request access_token / refresh_token using the authorization_code retrieved
function getToken(code){
    var postBody = 'client_id=' + urlEncode(APP_ID);
    postBody += '&scope=' + SCOPE;
    postBody += '&code=' + code;
    postBody += '&redirect_uri=' + urlEncode(REDIRECT_URI);
    postBody += '&grant_type=authorization_code';
    postBody += '&client_secret=' + APP_SECRET;
    
    httpPost(TOKEN_URL, postBody, 'getTokenSuccess', 'getTokenFail');
}

function getTokenSuccess(resultBody, headers){
    print('getTokenSuccess hdrs=' + headers);
    print('resultBody=' + resultBody);
    var res = JSON.parse(resultBody);
    OAUTH_ACCESS_TOKEN = res['access_token'];
    OAUTH_REFRESH_TOKEN = res['refresh_token'];
    setCookie('oauth_access_token', OAUTH_ACCESS_TOKEN);
    setCookie('oauth_refresh_token', OAUTH_REFRESH_TOKEN);
    callAction("show_page_by_name","home",3);
}

function getTokenFail(message, status, body){
    print('getTokenFail hdrs=' + message);
}


var sharePoint_JSON = "[]";
var feed_list_global = null;

registerAction('getSharePointRootLists', '', 'Get SharePoint Root Lists', '');
function getSharePointRootLists(){
    
    var accessToken = getCookie('oauth_access_token');
    
    print("access token= " + accessToken);
    
    var url = "https://graph.microsoft.com/beta/sites/root/lists";
    
    var header = 'Authorization: Bearer ' + accessToken;
    
    httpGetHeaders(url, header, 'getListsSuccess', 'getListsFail');
}


registerFeed('SharePointLists', 'SharePoint Lists', ''); 

function SharePointLists(component, messageBody) {
    
    if(sharePoint_JSON == "[]"){
        var tmpJSON = '[{"name":"' +  "" + '","item_id":"' + "" + '"}]';
        feed_list_global = component;
        setCustomFeed(component, tmpJSON); 
    
    }else{
        
        setCustomFeed(component, sharePoint_JSON); 
    }
}

function getListsSuccess(result){
    
    print("result= "+ result);
    var JSONData = JSON.parse(result);
    sharePoint_JSON = sharePoint_JSON.substring(0, sharePoint_JSON.length - 1);
    for(item in JSONData.value){
        
        if(JSONData.value[item].list.hidden == false){
              lists[JSONData.value[item].name] = [JSONData.value[item].id];
              sharePoint_JSON += '{"name":"' + JSONData.value[item].name + '","item_id":"' + JSONData.value[item].id + '"},';
        }  
    }
    sharePoint_JSON = sharePoint_JSON.substring(0, sharePoint_JSON.length - 1);
    sharePoint_JSON += "]";
    if(feed_list_global!=null){
        setCustomFeed(feed_list_global, sharePoint_JSON);
    }
    else{
        print("No feedlist comp set....");
    }
}

function getListsFail(error){
    
    print("ERROR GETTING SP DATA: " + error);

}
